searchNodes=[{"ref":"Zippex.html","title":"Zippex","type":"module","doc":"A Zipper is a representation of an aggregate data structure which allows it to be traversed and updated arbitrarily. This module implements tree-like semantics for traversing a data structure. Focus The current node of the zipper, also known as the focus node, can be retrieved by calling the focus/1 function. The following functions provide other information relating to the focus node: lefts/1 - returns the left siblings of the focus node rights/1 - returns the rights siblings of the focus node path/1 - returns the path to the focus node from the root Traversal The focus can be moved using the following functions: head/1 - moves to the root node down/1 - moves to the first child of the focus node up/1 - moves to the parent of the focus node left/1 - moves to the left sibling of the focus node leftmost/1 - moves to the leftmost sibling of the focus node right/1 - moves to the right sibling of the focus node rightmost/1 - moves to the rightmost sibling of the focus node next/1 - moves to the next node in a depth-first traversal prev/1 - moves to the previous node in a depth-first traversal Enumeration Zippex implements the Enumerable protocol, which allows it&#39;s values to be enumerated in a depth-first traversal. Updates The focus node can be modified using the functions edit/2 or edit/3. It can be removed, along with it&#39;s children, using the remove/1 function, after which the focus is moved to the previous node in a depth-first traversal."},{"ref":"Zippex.html#down/1","title":"Zippex.down/1","type":"function","doc":"Moves to the first child of the focus node. Returns the updated zipper, or nil if the focus node has no children."},{"ref":"Zippex.html#edit/2","title":"Zippex.edit/2","type":"function","doc":"Modifies the focus node by applying a function to it."},{"ref":"Zippex.html#edit/3","title":"Zippex.edit/3","type":"function","doc":"Modifies the focus node by applying a function to it."},{"ref":"Zippex.html#focus/1","title":"Zippex.focus/1","type":"function","doc":"Returns the focus node of a zipper."},{"ref":"Zippex.html#head/1","title":"Zippex.head/1","type":"function","doc":"Moves to the head of the zipper."},{"ref":"Zippex.html#left/1","title":"Zippex.left/1","type":"function","doc":"Moves to the left sibling of the focus node. Returns the updated zipper, or nil if the focus node has no left sibling."},{"ref":"Zippex.html#leftmost/1","title":"Zippex.leftmost/1","type":"function","doc":"Moves to the leftmost sibling of the focus node. Returns the updated zipper."},{"ref":"Zippex.html#lefts/1","title":"Zippex.lefts/1","type":"function","doc":"Returns the left siblings of the focus node."},{"ref":"Zippex.html#new/4","title":"Zippex.new/4","type":"function","doc":"Returns a new Zipper for a given node element. is_branch_fun receives a node and returns true if it is a branch, or false otherwise. children_fun receives a node (which is a branch) and returns a list of it&#39;s child nodes. make_node_fun receives a parent node and a list of child nodes and returns a new node."},{"ref":"Zippex.html#next/1","title":"Zippex.next/1","type":"function","doc":"Moves to the next node of the focus node in a depth-first traversal."},{"ref":"Zippex.html#path/1","title":"Zippex.path/1","type":"function","doc":"Returns the path to the focus node."},{"ref":"Zippex.html#prev/1","title":"Zippex.prev/1","type":"function","doc":"Moves to the previous node of the focus node in a depth-first traversal."},{"ref":"Zippex.html#remove/1","title":"Zippex.remove/1","type":"function","doc":"Removes the focus node, moving the focus to the node that would have preceded it in a depth-first traversal."},{"ref":"Zippex.html#right/1","title":"Zippex.right/1","type":"function","doc":"Moves to the right sibling of the focus node. Returns the updated zipper, or nil if the focus node has no right sibling."},{"ref":"Zippex.html#rightmost/1","title":"Zippex.rightmost/1","type":"function","doc":"Moves to the rightmost sibling of the focus node. Returns the updated zipper."},{"ref":"Zippex.html#rights/1","title":"Zippex.rights/1","type":"function","doc":"Returns the right siblings of the focus node."},{"ref":"Zippex.html#root/1","title":"Zippex.root/1","type":"function","doc":"Returns the root node of the zipper."},{"ref":"Zippex.html#up/1","title":"Zippex.up/1","type":"function","doc":"Moves to the parent of the focus node. Returns the updated zipper, or nil if the focus node has no parent."},{"ref":"Zippex.html#t:args/0","title":"Zippex.args/0","type":"type","doc":""},{"ref":"Zippex.html#t:edit_fun/0","title":"Zippex.edit_fun/0","type":"type","doc":""},{"ref":"Zippex.html#t:edit_with_args_fun/0","title":"Zippex.edit_with_args_fun/0","type":"type","doc":""},{"ref":"Zippex.html#t:element/0","title":"Zippex.element/0","type":"type","doc":""},{"ref":"Zippex.html#t:t/0","title":"Zippex.t/0","type":"type","doc":""},{"ref":"Zippex.Context.html","title":"Zippex.Context","type":"module","doc":"The context of a Zippex zipper. This module is used internally by Zippex and should not be accessed directly. The Context struct contains the following fields: parent - The parent of the focus node (or nil) ctx - The parent context (or nil) left - A list of left siblings of the focus node right - A list of right siblings of the focus node dirty - true iff the focus node or any of it&#39;s children have been modified"},{"ref":"Zippex.Context.html#path/2","title":"Zippex.Context.path/2","type":"function","doc":"Returns the path to the focus node."},{"ref":"Zippex.Context.html#t:element/0","title":"Zippex.Context.element/0","type":"type","doc":""},{"ref":"Zippex.Context.html#t:t/0","title":"Zippex.Context.t/0","type":"type","doc":""},{"ref":"Zippex.Meta.html","title":"Zippex.Meta","type":"module","doc":"The metadata of a Zippex zipper. The Meta struct contains the following fields: is_branch - A function that receives a node and returns true if the node is a branch children - A function that receives a node and returns it&#39;s children make_node - A function that receives a node and a list of children and returns a new node"},{"ref":"Zippex.Meta.html#children/2","title":"Zippex.Meta.children/2","type":"function","doc":"Applies the children function on a node"},{"ref":"Zippex.Meta.html#is_branch/2","title":"Zippex.Meta.is_branch/2","type":"function","doc":"Applies the is_branch function on a node"},{"ref":"Zippex.Meta.html#make_node/3","title":"Zippex.Meta.make_node/3","type":"function","doc":"Applies the make_node function on a node and list of children"},{"ref":"Zippex.Meta.html#new/3","title":"Zippex.Meta.new/3","type":"function","doc":"Returns a new Meta struct"},{"ref":"Zippex.Meta.html#t:children_fun/0","title":"Zippex.Meta.children_fun/0","type":"type","doc":""},{"ref":"Zippex.Meta.html#t:element/0","title":"Zippex.Meta.element/0","type":"type","doc":""},{"ref":"Zippex.Meta.html#t:is_branch_fun/0","title":"Zippex.Meta.is_branch_fun/0","type":"type","doc":""},{"ref":"Zippex.Meta.html#t:make_node_fun/0","title":"Zippex.Meta.make_node_fun/0","type":"type","doc":""},{"ref":"Zippex.Meta.html#t:t/0","title":"Zippex.Meta.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Zippex","type":"extras","doc":"Zippex A Zipper is a representation of an aggregate data structure which allows it to be traversed and updated arbitrarily. The Zippex module provides a generic zipper for structures with tree-like semantics. Zippex is inspired by other zipper implementations, notably: clojure.zip - Clojure&#39;s zipper library inaka/zipper - A generic Zipper implementation in Erlang Exercism&#39;s Zipper exercise"},{"ref":"readme.html#installation","title":"Zippex - Installation","type":"extras","doc":"The package can be installed by adding zippex to your list of dependencies in mix.exs: def deps do [ {:zippex, &quot;~&gt; 1.0.0&quot;} ] end"},{"ref":"readme.html#usage","title":"Zippex - Usage","type":"extras","doc":"The docs can be found at https://hexdocs.pm/zippex. Also see Zippex unit tests for usage examples."}]